﻿package
{
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.system.ApplicationDomain;
	import flash.system.LoaderContext;
	import flash.text.TextField;
	import flash.net.URLRequest;
	import flash.utils.describeType;
	
	[Frame(factoryClass="BadgePreloader")]
	public class ChatClientBadge extends MovieClip
	{
		private static const BROWSERAPI_URL_BASE:String = "http://airdownload.adobe.com/air/browserapi";
		public var button:SimpleButton;
		public var debug:TextField;
		
		private var airVersion:String;
		private var appURL:String;
		private var loader:Loader;
		private var air:Object;
		
		public function ChatClientBadge():void
		{
			super();
			
			debug.text = "";
			debug.visible = false;
			
			try
			{
				airVersion 			= String(loaderInfo.parameters["airversion"]);
				appURL 				= validateURL(encodeURI(loaderInfo.parameters["appurl"]));
			}
			catch(err:Error)
			{
				airVersion  		= "";
				appURL				= "";
			}
			
			addEventListener(MouseEvent.CLICK, onButtonClicked);
			
			gotoAndStop("loading");
			
			loader = new Loader();
			var loaderContext:LoaderContext = new LoaderContext();
			loaderContext.applicationDomain = ApplicationDomain.currentDomain;

			loader.contentLoaderInfo.addEventListener(Event.INIT, onInit);
			try
			{
				loader.load(new URLRequest(BROWSERAPI_URL_BASE + "/air.swf"), loaderContext);
			}
			catch(loadError:Error)
			{
				log(loadError.message);
			}
		}
		
		private function log(o:*):void
		{
			debug.text = o;
			if(debug.text.length < 1)
			{
				debug.visible = false;
			}
			else
			{
				debug.visible = true;
			}
		}
		
		private function onInit(event:Event):void
		{
			air = event.target.content;
			switch(air.getStatus())
			{
				case "installed":
					log("");
					gotoAndStop("air-installed");
					break;
					
				case "available":
					gotoAndStop("air-available");
					break;
					
				case "unavailable":
					gotoAndStop("air-unavilable");
					break;
			}
		}
		
		private function onButtonClicked(event:MouseEvent):void
		{
			if(event.target != button) return;
			try
			{
				switch(air.getStatus())
				{
					case "installed" :
						gotoAndStop("download-file");
						air.installApplication(appURL, airVersion);
						break;
					case "available" :
						gotoAndStop("installing-air");
						log(appURL);
						try
						{
							air.installApplication(appURL, airVersion);
						}
						catch(errrrrr:Error)
						{
							log(errrrrr.message);
						}
						break;
					case "unavailable":
						// do nothing
						break;
				}
			}
			catch(err:Error)
			{
				log(err.message);
			}
		}
		
		// Validate URL: only allow HTTP, HTTPS scheme or relative path
		// Return null if not a valid URL
		private function validateURL(url:String):String {
			if (url && url.length > 0) {
				var schemeMarker:int = url.indexOf(":");
				if (schemeMarker < 0) {
					schemeMarker = url.indexOf("%3a");
				}
				if (schemeMarker < 0) {
					schemeMarker = url.indexOf("%3A");
				}
				if (schemeMarker > 0) {
					var scheme:String = url.substr(0, schemeMarker).toLowerCase();
					if (scheme != "http" && scheme != "https" && scheme != "ftp") {
						url = null;
					}
				}
			}
			return url;
		}
		
		
	}
	
}